diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/callback.h ns-3.31/src/core/model/callback.h
--- ns-3.30.1/src/core/model/callback.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/callback.h	2020-06-27 17:38:30.000000000 -0700
@@ -55,41 +55,7 @@
  * Callback implementation classes
  */
 /**
- * \ingroup callback
- * \defgroup makecallbackmemptr MakeCallback from member function pointer
- *
- * Build Callbacks for class method members which take varying numbers
- * of arguments and potentially returning a value.
- *
- * Generally the \c MakeCallback functions are invoked with the
- * method function address first, followed by the \c this pointer:
- * \code
- *   MakeCallback ( & MyClass::Handler, this);
- * \endcode
- *
- * There is not a version with bound arguments.  You may be able to
- * get the same result by using \c MakeBoundCallback with a \c static
- * member function, as in:
- * \code
- *   MakeBoundCallback ( & MyClass::StaticHandler, this);
- * \endcode
- * This still leaves two argument slots available for binding.
- */
-/**
- * \ingroup callback
- * \defgroup makecallbackfnptr MakeCallback from function pointers
- *
- * Build Callbacks for functions which take varying numbers of arguments
- * and potentially returning a value.
- */
-/**
- * \ingroup callback
- * \defgroup makenullcallback MakeCallback with no arguments
- *
- * Define empty (Null) callbacks as placeholders for unset callback variables.
- */
-/**
- * \ingroup callback
+ * \ingroup callbackimpl
  * \defgroup makeboundcallback MakeBoundCallback from functions bound with up to three arguments.
  *
  * Build bound Callbacks which take varying numbers of arguments,
@@ -102,21 +68,23 @@
  * or not we really want to use it.
  */
 
-  
+
 /**
- * \ingroup makecallbackmemptr
+ * \ingroup callbackimpl
  *
  * Trait class to convert a pointer into a reference,
  * used by MemPtrCallBackImpl
+ * \tparam T \deduced The type being converted.
  */
 template <typename T>
 struct CallbackTraits;
 
 /**
- * \ingroup makecallbackmemptr
+ * \ingroup callbackimpl
  *
  * Trait class to convert a pointer into a reference,
  * used by MemPtrCallBackImpl
+ * \tparam T \deduced The type being converted.
  */
 template <typename T>
 struct CallbackTraits<T *>
@@ -140,7 +108,8 @@
 {
 public:
   /** Virtual destructor */
-  virtual ~CallbackImplBase () {}
+  virtual ~CallbackImplBase ()
+  {}
   /**
    * Equality test
    *
@@ -163,8 +132,8 @@
   /**
    * Helper to get the C++ typeid as a string.
    *
-   * \tparam T The type of the argument.
-   * \returns The result of applying typeid to the template type \p T.
+   * \tparam T \explicit The type of the argument.
+   * \returns The result of applying typeid to the template type \pname{T}.
    */
   template <typename T>
   static std::string GetCppTypeid (void)
@@ -186,10 +155,13 @@
 /**
  * \ingroup callbackimpl
  * The unqualified CallbackImpl class
+ * \tparam R \explicit The return type of the Callback.
+ * The remaining template arguments are the types of any arguments
+ * to the Callback.
  */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9>
 class CallbackImpl;
-  
+
 /**
  * \ingroup callbackimpl
  * CallbackImpl classes with varying numbers of argument types
@@ -198,10 +170,12 @@
  */
 /** CallbackImpl class with no arguments. */
 template <typename R>
-class CallbackImpl<R,empty,empty,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,empty,empty,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (void) = 0;      //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (void) = 0;      //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -217,10 +191,12 @@
 };
 /** CallbackImpl class with one argument. */
 template <typename R, typename T1>
-class CallbackImpl<R,T1,empty,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,empty,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1) = 0;        //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1) = 0;        //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -237,10 +213,12 @@
 };
 /** CallbackImpl class with two arguments. */
 template <typename R, typename T1, typename T2>
-class CallbackImpl<R,T1,T2,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,empty,empty,empty,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2) = 0;    //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2) = 0;    //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -258,10 +236,12 @@
 };
 /** CallbackImpl class with three arguments. */
 template <typename R, typename T1, typename T2, typename T3>
-class CallbackImpl<R,T1,T2,T3,empty,empty,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,empty,empty,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -280,10 +260,12 @@
 };
 /** CallbackImpl class with four arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4>
-class CallbackImpl<R,T1,T2,T3,T4,empty,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,T4,empty,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -303,10 +285,12 @@
 };
 /** CallbackImpl class with five arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5>
-class CallbackImpl<R,T1,T2,T3,T4,T5,empty,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,T4,T5,empty,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4, T5) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4, T5) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -327,10 +311,12 @@
 };
 /** CallbackImpl class with six arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-class CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4, T5, T6) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4, T5, T6) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -352,10 +338,12 @@
 };
 /** CallbackImpl class with seven arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
-class CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4, T5, T6, T7) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4, T5, T6, T7) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -378,10 +366,12 @@
 };
 /** CallbackImpl class with eight arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8>
-class CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,empty> : public CallbackImplBase {
+class CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,empty> : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4, T5, T6, T7, T8) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4, T5, T6, T7, T8) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -405,10 +395,12 @@
 };
 /** CallbackImpl class with nine arguments. */
 template <typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9>
-class CallbackImpl : public CallbackImplBase {
+class CallbackImpl : public CallbackImplBase
+{
 public:
-  virtual ~CallbackImpl () {}
-  virtual R operator() (T1, T2, T3, T4, T5, T6, T7, T8, T9) = 0;  //!< Abstract operator
+  virtual ~CallbackImpl ()
+  {}
+  virtual R operator() (T1, T2, T3, T4, T5, T6, T7, T8, T9) = 0;  //!< \return Callback value
   virtual std::string GetTypeid (void) const
   {
     return DoGetTypeid ();
@@ -437,31 +429,37 @@
 /**
  * \ingroup callbackimpl
  * CallbackImpl with functors
+ * \tparam T \deduced Function pointer type.
  */
 template <typename T, typename R, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7, typename T8, typename T9>
-class FunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> {
+class FunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9>
+{
 public:
   /**
    * Construct from a functor
    *
-   * \param [in] functor The functor 
+   * \param [in] functor The functor
    */
   FunctorCallbackImpl (T const &functor)
-    : m_functor (functor) {}
-  virtual ~FunctorCallbackImpl () {}
+    : m_functor (functor)
+  {}
+  virtual ~FunctorCallbackImpl ()
+  {}
   /**
    * Functor with varying numbers of arguments
    * @{
    */
   /** \return Callback value */
-  R operator() (void) {
+  R operator() (void)
+  {
     return m_functor ();
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) {
+  R operator() (T1 a1)
+  {
     return m_functor (a1);
   }
   /**
@@ -469,7 +467,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2) {
+  R operator() (T1 a1,T2 a2)
+  {
     return m_functor (a1,a2);
   }
   /**
@@ -478,7 +477,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3) {
+  R operator() (T1 a1,T2 a2,T3 a3)
+  {
     return m_functor (a1,a2,a3);
   }
   /**
@@ -488,7 +488,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4)
+  {
     return m_functor (a1,a2,a3,a4);
   }
   /**
@@ -499,7 +500,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5)
+  {
     return m_functor (a1,a2,a3,a4,a5);
   }
   /**
@@ -511,7 +513,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6)
+  {
     return m_functor (a1,a2,a3,a4,a5,a6);
   }
   /**
@@ -524,7 +527,8 @@
    * \param [in] a7 Seventh argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7)
+  {
     return m_functor (a1,a2,a3,a4,a5,a6,a7);
   }
   /**
@@ -538,7 +542,8 @@
    * \param [in] a8 eighth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8)
+  {
     return m_functor (a1,a2,a3,a4,a5,a6,a7,a8);
   }
   /**
@@ -553,7 +558,8 @@
    * \param [in] a9 ninth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8,T9 a9) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8,T9 a9)
+  {
     return m_functor (a1,a2,a3,a4,a5,a6,a7,a8,a9);
   }
   /**@}*/
@@ -563,8 +569,9 @@
    * \param [in] other CallbackImpl Ptr
    * \return \c true if this and other have the same functor
    */
-  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const {
-    FunctorCallbackImpl<T,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *otherDerived = 
+  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const
+  {
+    FunctorCallbackImpl<T,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *otherDerived =
       dynamic_cast<FunctorCallbackImpl<T,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *> (PeekPointer (other));
     if (otherDerived == 0)
       {
@@ -576,16 +583,20 @@
       }
     return true;
   }
+
 private:
   T m_functor;                          //!< the functor
 };
 
 /**
- * \ingroup makecallbackmemptr
+ * \ingroup callbackimpl
  * CallbackImpl for pointer to member functions
+ * \tparam OBJ_PTR \deduced Type of the target object, as a pointer.
+ * \tparam MEM_PTR \deduced Type of the class member function.
  */
 template <typename OBJ_PTR, typename MEM_PTR, typename R, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9>
-class MemPtrCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9> {
+class MemPtrCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,T9>
+{
 public:
   /**
    * Construct from an object pointer and member function pointer
@@ -594,21 +605,25 @@
    * \param [in] memPtr The object class member function
    */
   MemPtrCallbackImpl (OBJ_PTR const&objPtr, MEM_PTR memPtr)
-    : m_objPtr (objPtr), m_memPtr (memPtr) {}
-  virtual ~MemPtrCallbackImpl () {}
+    : m_objPtr (objPtr), m_memPtr (memPtr)
+  {}
+  virtual ~MemPtrCallbackImpl ()
+  {}
   /**
    * Functor with varying numbers of arguments
    * @{
    */
   /** \return Callback value */
-  R operator() (void) {
+  R operator() (void)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)();
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) {
+  R operator() (T1 a1)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1);
   }
   /**
@@ -616,7 +631,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2) {
+  R operator() (T1 a1,T2 a2)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2);
   }
   /**
@@ -625,7 +641,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3) {
+  R operator() (T1 a1,T2 a2,T3 a3)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3);
   }
   /**
@@ -635,7 +652,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4);
   }
   /**
@@ -646,7 +664,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4, a5);
   }
   /**
@@ -658,7 +677,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4, a5, a6);
   }
   /**
@@ -671,7 +691,8 @@
    * \param [in] a7 Seventh argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4, a5, a6, a7);
   }
   /**
@@ -685,7 +706,8 @@
    * \param [in] a8 Eighth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4, a5, a6, a7, a8);
   }
   /**
@@ -700,7 +722,8 @@
    * \param [in] a9 Ninth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8, T9 a9) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8, T9 a9)
+  {
     return ((CallbackTraits<OBJ_PTR>::GetReference (m_objPtr)).*m_memPtr)(a1, a2, a3, a4, a5, a6, a7, a8, a9);
   }
   /**@}*/
@@ -710,20 +733,22 @@
    * \param [in] other Callback Ptr
    * \return \c true if we have the same object and member function
    */
-  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const {
-    MemPtrCallbackImpl<OBJ_PTR,MEM_PTR,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *otherDerived = 
+  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const
+  {
+    MemPtrCallbackImpl<OBJ_PTR,MEM_PTR,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *otherDerived =
       dynamic_cast<MemPtrCallbackImpl<OBJ_PTR,MEM_PTR,R,T1,T2,T3,T4,T5,T6,T7,T8,T9> const *> (PeekPointer (other));
     if (otherDerived == 0)
       {
         return false;
       }
-    else if (otherDerived->m_objPtr != m_objPtr ||
-             otherDerived->m_memPtr != m_memPtr)
+    else if (otherDerived->m_objPtr != m_objPtr
+             || otherDerived->m_memPtr != m_memPtr)
       {
         return false;
       }
     return true;
   }
+
 private:
   OBJ_PTR const m_objPtr;               //!< the object pointer
   MEM_PTR m_memPtr;                     //!< the member function pointer
@@ -732,32 +757,43 @@
 /**
  * \ingroup callbackimpl
  * CallbackImpl for functors with first argument bound at construction
+ * \tparam T  \explicit Type of the functor.
+ * \tparam TX \explicit Type of the bound argument.
  */
 template <typename T, typename R, typename TX, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7, typename T8>
-class BoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,empty> {
+class BoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,T8,empty>
+{
 public:
   /**
    * Construct from functor and a bound argument
-   * \param [in] functor The functor 
+   * \tparam FUNCTOR \deduced The actual type of the functor.
+   *         This must be convertible to \pname{T}.
+   * \tparam ARG \deduced The actual type of the bound argument.
+   *         This must be convertible to type \pname{TX}.
+   * \param [in] functor The functor
    * \param [in] a The argument to bind
    */
   template <typename FUNCTOR, typename ARG>
   BoundFunctorCallbackImpl (FUNCTOR functor, ARG a)
-    : m_functor (functor), m_a (a) {}
-  virtual ~BoundFunctorCallbackImpl () {}
+    : m_functor (functor), m_a (a)
+  {}
+  virtual ~BoundFunctorCallbackImpl ()
+  {}
   /**
    * Functor with varying numbers of arguments
    * @{
    */
   /** \return Callback value */
-  R operator() (void) {
+  R operator() (void)
+  {
     return m_functor (m_a);
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) {
+  R operator() (T1 a1)
+  {
     return m_functor (m_a,a1);
   }
   /**
@@ -765,7 +801,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2) {
+  R operator() (T1 a1,T2 a2)
+  {
     return m_functor (m_a,a1,a2);
   }
   /**
@@ -774,7 +811,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3) {
+  R operator() (T1 a1,T2 a2,T3 a3)
+  {
     return m_functor (m_a,a1,a2,a3);
   }
   /**
@@ -784,7 +822,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4)
+  {
     return m_functor (m_a,a1,a2,a3,a4);
   }
   /**
@@ -795,7 +834,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5)
+  {
     return m_functor (m_a,a1,a2,a3,a4,a5);
   }
   /**
@@ -807,7 +847,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6)
+  {
     return m_functor (m_a,a1,a2,a3,a4,a5,a6);
   }
   /**
@@ -820,7 +861,8 @@
    * \param [in] a7 Seventh argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7)
+  {
     return m_functor (m_a,a1,a2,a3,a4,a5,a6,a7);
   }
   /**
@@ -834,7 +876,8 @@
    * \param [in] a8 Eighth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7,T8 a8)
+  {
     return m_functor (m_a,a1,a2,a3,a4,a5,a6,a7,a8);
   }
   /**@}*/
@@ -844,20 +887,22 @@
    * \param [in] other Callback Ptr
    * \return \c true if we have the same functor and bound arguments
    */
-  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const {
-    BoundFunctorCallbackImpl<T,R,TX,T1,T2,T3,T4,T5,T6,T7,T8> const *otherDerived = 
+  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const
+  {
+    BoundFunctorCallbackImpl<T,R,TX,T1,T2,T3,T4,T5,T6,T7,T8> const *otherDerived =
       dynamic_cast<BoundFunctorCallbackImpl<T,R,TX,T1,T2,T3,T4,T5,T6,T7,T8> const *> (PeekPointer (other));
     if (otherDerived == 0)
       {
         return false;
       }
-    else if (otherDerived->m_functor != m_functor ||
-             otherDerived->m_a != m_a)
+    else if (otherDerived->m_functor != m_functor
+             || otherDerived->m_a != m_a)
       {
         return false;
       }
     return true;
   }
+
 private:
   T m_functor;                          //!< The functor
   typename TypeTraits<TX>::ReferencedType m_a;  //!< the bound argument
@@ -866,33 +911,47 @@
 /**
  * \ingroup callbackimpl
  * CallbackImpl for functors with first two arguments bound at construction
+ * \tparam T  \explicit Type of the functor.
+ * \tparam TX1 \explicit Type of the first bound argument.
+ * \tparam TX2 \explicit Type of the second bound argument.
  */
 template <typename T, typename R, typename TX1, typename TX2, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6, typename T7>
-class TwoBoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty> {
+class TwoBoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,T7,empty,empty>
+{
 public:
   /**
    * Construct from functor and two arguments
+   * \tparam FUNCTOR \deduced The actual type of the functor.
+   *         This must be convertible to \pname{T}.
+   * \tparam ARG1 \deduced The actual type of the first bound argument.
+   *         This must be convertible to type \pname{TX1}.
+   * \tparam ARG2 \deduced The actual type of the second bound argument.
+   *         This must be convertible to type \pname{TX2}.
    * \param [in] functor The functor
    * \param [in] arg1 The first argument to bind
    * \param [in] arg2 The second argument to bind
    */
   template <typename FUNCTOR, typename ARG1, typename ARG2>
   TwoBoundFunctorCallbackImpl (FUNCTOR functor, ARG1 arg1, ARG2 arg2)
-    : m_functor (functor), m_a1 (arg1), m_a2 (arg2) {}
-  virtual ~TwoBoundFunctorCallbackImpl () {}
+    : m_functor (functor), m_a1 (arg1), m_a2 (arg2)
+  {}
+  virtual ~TwoBoundFunctorCallbackImpl ()
+  {}
   /**
    * Functor with varying numbers of arguments
    * @{
    */
   /** \return Callback value */
-  R operator() (void) {
+  R operator() (void)
+  {
     return m_functor (m_a1,m_a2);
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) {
+  R operator() (T1 a1)
+  {
     return m_functor (m_a1,m_a2,a1);
   }
   /**
@@ -900,7 +959,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2) {
+  R operator() (T1 a1,T2 a2)
+  {
     return m_functor (m_a1,m_a2,a1,a2);
   }
   /**
@@ -909,7 +969,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3) {
+  R operator() (T1 a1,T2 a2,T3 a3)
+  {
     return m_functor (m_a1,m_a2,a1,a2,a3);
   }
   /**
@@ -919,7 +980,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4)
+  {
     return m_functor (m_a1,m_a2,a1,a2,a3,a4);
   }
   /**
@@ -930,7 +992,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5)
+  {
     return m_functor (m_a1,m_a2,a1,a2,a3,a4,a5);
   }
   /**
@@ -942,7 +1005,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6)
+  {
     return m_functor (m_a1,m_a2,a1,a2,a3,a4,a5,a6);
   }
   /**
@@ -955,7 +1019,8 @@
    * \param [in] a7 Seventh argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6,T7 a7)
+  {
     return m_functor (m_a1,m_a2,a1,a2,a3,a4,a5,a6,a7);
   }
   /**@}*/
@@ -965,20 +1030,22 @@
    * \param [in] other Callback Ptr
    * \return \c true if we have the same functor and bound arguments
    */
-  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const {
-    TwoBoundFunctorCallbackImpl<T,R,TX1,TX2,T1,T2,T3,T4,T5,T6,T7> const *otherDerived = 
+  virtual bool IsEqual (Ptr<const CallbackImplBase> other) const
+  {
+    TwoBoundFunctorCallbackImpl<T,R,TX1,TX2,T1,T2,T3,T4,T5,T6,T7> const *otherDerived =
       dynamic_cast<TwoBoundFunctorCallbackImpl<T,R,TX1,TX2,T1,T2,T3,T4,T5,T6,T7> const *> (PeekPointer (other));
     if (otherDerived == 0)
       {
         return false;
       }
-    else if (otherDerived->m_functor != m_functor ||
-             otherDerived->m_a1 != m_a1 || otherDerived->m_a2 != m_a2)
+    else if (otherDerived->m_functor != m_functor
+             || otherDerived->m_a1 != m_a1 || otherDerived->m_a2 != m_a2)
       {
         return false;
       }
     return true;
   }
+
 private:
   T m_functor;                                    //!< The functor
   typename TypeTraits<TX1>::ReferencedType m_a1;  //!< first bound argument
@@ -988,12 +1055,25 @@
 /**
  * \ingroup callbackimpl
  * CallbackImpl for functors with first three arguments bound at construction
+ * \tparam T  \explicit Type of the functor.
+ * \tparam TX1 \explicit Type of the first bound argument.
+ * \tparam TX2 \explicit Type of the second bound argument.
+ * \tparam TX3 \explicit Type of the third bound argument.
  */
 template <typename T, typename R, typename TX1, typename TX2, typename TX3, typename T1, typename T2, typename T3, typename T4,typename T5, typename T6>
-class ThreeBoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty> {
+class ThreeBoundFunctorCallbackImpl : public CallbackImpl<R,T1,T2,T3,T4,T5,T6,empty,empty,empty>
+{
 public:
   /**
    * Construct from functor and three arguments
+   * \tparam FUNCTOR \deduced The actual type of the functor.
+   *         This must be convertible to \pname{T}.
+   * \tparam ARG1 \deduced The actual type of the first bound argument.
+   *         This must be convertible to type \pname{TX1}.
+   * \tparam ARG2 \deduced The actual type of the second bound argument.
+   *         This must be convertible to type \pname{TX2}.
+   * \tparam ARG3 \deduced The actual type of the third bound argument.
+   *         This must be convertible to type \pname{TX3}.
    * \param [in] functor The functor
    * \param [in] arg1 The first argument to bind
    * \param [in] arg2 The second argument to bind
@@ -1001,21 +1081,25 @@
    */
   template <typename FUNCTOR, typename ARG1, typename ARG2, typename ARG3>
   ThreeBoundFunctorCallbackImpl (FUNCTOR functor, ARG1 arg1, ARG2 arg2, ARG3 arg3)
-    : m_functor (functor), m_a1 (arg1), m_a2 (arg2), m_a3 (arg3) {}
-  virtual ~ThreeBoundFunctorCallbackImpl () {}
+    : m_functor (functor), m_a1 (arg1), m_a2 (arg2), m_a3 (arg3)
+  {}
+  virtual ~ThreeBoundFunctorCallbackImpl ()
+  {}
   /**
    * Functor with varying numbers of arguments
    * @{
    */
   /** \return Callback value */
-  R operator() (void) {
+  R operator() (void)
+  {
     return m_functor (m_a1,m_a2,m_a3);
   }
   /**
    * \param [in] a1 First argument
    * \return Callback value
    */
-  R operator() (T1 a1) {
+  R operator() (T1 a1)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1);
   }
   /**
@@ -1023,7 +1107,8 @@
    * \param [in] a2 Second argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2) {
+  R operator() (T1 a1,T2 a2)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1,a2);
   }
   /**
@@ -1032,7 +1117,8 @@
    * \param [in] a3 Third argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3) {
+  R operator() (T1 a1,T2 a2,T3 a3)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1,a2,a3);
   }
   /**
@@ -1042,7 +1128,8 @@
    * \param [in] a4 Fourth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1,a2,a3,a4);
   }
   /**
@@ -1053,7 +1140,8 @@
    * \param [in] a5 Fifth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1,a2,a3,a4,a5);
   }
   /**
@@ -1065,7 +1153,8 @@
    * \param [in] a6 Sixth argument
    * \return Callback value
    */
-  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6) {
+  R operator() (T1 a1,T2 a2,T3 a3,T4 a4,T5 a5,T6 a6)
+  {
     return m_functor (m_a1,m_a2,m_a3,a1,a2,a3,a4,a5,a6);
   }
   /**@}*/
